getSF3.2000 <- function(summary.table, geo.filter, state, zip.file, working.dir="/"){
	# Load the data dictionaries...
	load(paste(system.file(package="UScensus"),'/data/data.dict.rda',sep=''))
	load(paste(system.file(package="UScensus"),'/data/geo.header.dict.rda',sep=''))
	
	# Unzip the geoheader file (and delete temporary zip file)
	unzip(zip.file,files=paste(state,'geo_uf3.zip',sep=''), exdir=working.dir, overwrite=TRUE)
	unzip(zipfile=paste(working.dir,state,'geo_uf3.zip',sep=''), exdir=working.dir, overwrite=TRUE)
	file.remove(paste(working.dir,state,'geo_uf3.zip',sep=''))

	# Load in the geoheader file
	geo.header <- read.fwf(paste(working.dir,state,'geo.uf3',sep=''), 	widths=as.numeric(as.character(geo.header.dict$WIDTH)), col.names=geo.header.dict$VARNAME, 		fill=TRUE, colClasses='character')
	file.remove(paste(working.dir,state,'geo.uf3',sep=''))


	# Filter the geoheader file.  We will multiply true-false statements to find rows matching filter criteria.
match.product <- rep(1,length=nrow(geo.header))
for(i in 1:length(geo.filter)){
	match.product <- match.product * match(geo.header[,as.character(names(geo.filter)[i])],geo.filter[[i]],nomatch=0)}
select.rows <- which(match.product>0)

# Now find which files we need
# Filter the Data Dictionary
dict.rows <- which(match(data.dict$Table,summary.table,nomatch=0)>0)

this.dictionary <- data.dict[dict.rows,]
file.numbers <- unique(this.dictionary$FileNo)


data.out <- geo.header[select.rows,]
# Set row names to LOGRECNO
row.names(data.out) <- data.out$LOGRECNO
for(i in 1:length(file.numbers)){
	# Unzip uf3 file
	unzip(zip.file,files=paste(state,file.numbers[i],'_uf3.zip',sep=''), exdir=working.dir, overwrite=TRUE)
	unzip(zipfile=paste(working.dir,state,file.numbers[i],'_uf3.zip',sep=''), exdir=working.dir, overwrite=TRUE)
	file.remove(paste(working.dir,state,file.numbers[i],'_uf3.zip',sep=''))
	this.uf3 <- read.table(paste(working.dir,state,file.numbers[i],'.uf3',sep=''),sep=',',colClasses='character')
	file.remove(paste(working.dir,state,file.numbers[i],'.uf3',sep=''))
	row.names(this.uf3) <- this.uf3[,5]
	uf3.rows <- which(match(this.uf3$V5,geo.header$LOGRECNO[select.rows],nomatch=0)>0)
	# Complete the sanity check here...
	# Compare the number of expected columns with the number of actual columns...
	print('Sanity Check: email <nnagle@utk.edu> if numbers are not equal')
	print(ncol(this.uf3))
	print(max(data.dict[which(data.dict$FileNo==file.numbers[i]),6])+5)
	if(ncol(this.uf3)!=max(data.dict[which(data.dict$FileNo==file.numbers[i]),6])+5){warning('The actual uf3 file size does not match that expected.  These data are most certainly wrong. email <nnagle@utk.edu> with the Tables that created the error')}
	
	uf3.cols <- data.dict$column[which(as.double(data.dict$FileNo==file.numbers[i]) * match(data.dict$Table,summary.table,nomatch=0)>0)]
#	this.uf3<-this.uf3[uf3.rows,5+uf3.cols]
	names(this.uf3)[5+uf3.cols] <- data.dict$Field[uf3.cols]
	data.out <- cbind(data.out,this.uf3[as.character(row.names(data.out)),uf3.cols+5, drop=FALSE])
	}

return(data.out)
	}
	